// Main loop:
// 1 fork, in child:
// 1.1 For each page:
// 1.1.1 zero_page
// 1.1.2 read entire buffer

#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#define SIZE 4096

int main(int argc, char *argv[])
{
    int i,k,d = 0;
    int N = (argc==3 ? atoi(argv[1])/4 : 0);
    int ITER = (argc==3 ? atoi(argv[2]) : 0);
    if(N <= 0 || ITER <= 0) {
	puts("Usage: <program_name> kbytes iterations");
	exit(1);
    }

    unsigned char *mem = mmap(0, N*SIZE, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, 0, 0);
    if(mem == MAP_FAILED) perror("mmap");

    memset(mem, 'a', N*SIZE); /* force page presence */

    for(k = 0; k < ITER; k++) {
	int pid = fork();
	if(pid == -1)
    	    perror("fork");
	else if(pid == 0) { /* child */
	    unsigned char *p,*end;
	    for(i = 0; i < N; i++) {
		p = mem + i*SIZE;
        	*p = i; /* write forces COW (copy_page) */
		end = p + SIZE;
		while(p != end) { d ^= *p; p += 32; } /* use data */
	    }
    	    _exit(d/0x10000);
	} else /* parent */
    	    waitpid(pid, NULL, 0);
    }
    return d/0x10000; /* use d, or else gcc may optimize loads out! */
}
