// Main loop:
// 1. zero_page entire buffer
// 2. read entire buffer

#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#define SIZE 4096

int main(int argc, char *argv[])
{
    int i,k,d = 0;
    int N = (argc==3 ? atoi(argv[1])/4 : 0);
    int ITER = (argc==3 ? atoi(argv[2]) : 0);
    if(N <= 0 || ITER <= 0) {
	puts("Usage: <program_name> kbytes iterations");
	exit(1);
    }

    for(k = 0; k < ITER; k++) {
	unsigned char *mem,*p,*end;
	mem = mmap(0, N*SIZE, PROT_READ|PROT_WRITE,MAP_PRIVATE|MAP_ANONYMOUS, 0, 0);
	for(i = 0; i < N; i++) mem[i*SIZE] = i; /* write forces clear_page */
	p = mem;
	end = mem + N*SIZE;
	while(p != end) { d ^= *p; p += 32; } /* use data */
	munmap(mem, N*SIZE);
    }
    return d/0x10000; /* use d, or else gcc may optimize loads out! */
}
